/** GHDL vhpi C interface specifics
 *
 * (c) 2011, Martin Strubel <hackfin@section5.ch>
 *
 * Important: Note that a std_logic_vector array is passed in the
 * char * pointers, regardless of the bit order
 * (LSB to MSB) or (MSB downto LSB).
 *
 * Thus, for a MSB downto LSB array, you have to reverse the indexing!
 *
 */

#include <stdint.h>

/** char value definitions of std_logic_vector array:
 */

#define UNDEFINED 0
#define INVALID_X 1
#define LOW       2
#define HIGH      3
#define TRISTATE  4

/** Convert std_logic_vector to unsigned short */
int logic_to_uint(char *l, int nbits, uint32_t *val);
/** Convert std_logic_vector to unsigned short */
void uint_to_logic(char *l, int nbits, uint32_t val);

/** Debugging */

void dump_bits(unsigned char c);
void hexdump(char *buf, unsigned long n);
