/** \file helpers.c
 *
 * GHDL simulator interface auxiliaries
 *
 * (c) 2009-2011 Martin Strubel <hackfin@section5.ch>
 *
 */

#include <stdio.h>
#include "ghpi.h"

/** Dump buffer */

void hexdump(char *buf, unsigned long n)
{
	int i = 0;
	int c = 0;

	while (i < n) {
		// Testing: Bitreverse display:
		// printf("%02x ", reverse32(buf[2 * i]) >> 24);
		printf("%02x ", (unsigned char) buf[i]);
		c++;
		if (c == 16) { c = 0; printf("\r\n"); }
		i++;
	}
	if (c)
		printf("\r\n");
}

void dump_bits(unsigned char c)
{
	char *s = "UX01Z???";

	c &= 7;

	putchar(s[c]);
}

int logic_to_uint(char *l, int nbits, uint32_t *val)
{
	uint32_t v = 0;
	while (nbits--) {
		v <<= 1;
		switch (*l) {
			case HIGH: v |= 1; break;
			case LOW: break;
			default: return -1;
		}
		l++;
	}
	*val = v;
	return 0;
}

void uint_to_logic(char *l, int nbits, uint32_t val)
{
	uint32_t pos;
	
	while (nbits--) {
		pos = 1 << nbits;
		if (val & pos) {
			*l = HIGH;
		} else {
			*l = LOW;
		}
		l++;
	}
}


